/***
* DBED.PRG
* A sample program to demonstrate a conversion from DBEdit to TBrowse
* Uses the DBEdit pre-defined constants found in DBEDIT.CH
* Contains one calculated field
*
* External: DateAsAge() from Date.Prg (Clipper 5.0 sample program)
*
* Database: ROLO.DBF
*           FIELD      TYPE      LENGTH
*           Name       Character   30
*           Birthdate  Date         8
*           Phonemum   Numeric      7
*
* Indexes:  ROLONAME.NTX   Key: UPPER( Name )
*           ROLOBDAY.NTX        DTOS( Birthdate )
*/

#include "dbedit.ch"
#include "inkey.ch"

/***
* DBEd() --> NIL
*
*/
FUNCTION DBEd
   LOCAL acCols[3], acPics[3], acHeads[3], acFoots[3]
   LOCAL cColSep, cFootSep, cHeadSep

   acCols[1] :=  "Rolo->Name"
   acCols[2] :=  "DateAsAge(Rolo->BirthDate)"
   acCols[3] :=  "Rolo->PhoneNum"

   acPics[1] := ""
   acPics[2] := ""
   acPics[3] := "@R 999-9999"

   acHeads[1] := acFoots[1] := "Name"
   acHeads[2] := acFoots[2] := "Age"
   acHeads[3] := acFoots[3] := "Phone #"

   cHeadSep := ''
   cColSep  := '  '
   cFootSep := ''

   CLEAR SCREEN
   USE Rolo NEW

   @ 3, 10 TO 21, 70

   @ 22, 11 SAY 'Alt-B: Beginning, Alt-E: End'
   DBEDIT( 4, 11, 20, 69, acCols, "MyUdf", acPics, acHeads, cHeadSep, ;
           cColSep, cFootSep, acFoots )

   RETURN NIL


/***
* MyUdf( <nMode>, <nCol> ) --> nRet
* DBEdit user defined function
* 
*/
FUNCTION MyUdf( nMode, nCol )
   LOCAL nRet := DE_CONT
   LOCAL cString
   LOCAL nKey := LASTKEY()

   DO CASE
   CASE nMode == DE_IDLE
      cString := STR(RECNO(),3) + '/' + STR(LASTREC(),3)
      @ 22, 70-LEN(cString) SAY cString   

   CASE nMode == DE_HITTOP
      TONE( 523.3, 9 )

   CASE nMode == DE_HITBOTTOM
      TONE( 523.3, 9 )

   CASE nMode == DE_EXCEPT
      DO CASE
      CASE nKey == K_ESC
         nRet := DE_ABORT

      CASE nKey == K_ALT_E
         GO BOTTOM
         nRet := DE_REFRESH

      CASE nKey == K_ALT_B
         GO TOP
         nRet := DE_REFRESH

      ENDCASE

   ENDCASE

   RETURN (nRet)

/*** EOF: DBED.PRG ***/
