// Assign defaults to parameters that are NIL ( no arguments were passed )
//
// Syntax:
//     DEFAULT var TO value [,varN TO valueN,...]	 
//
// Example:
//     LOCAL nArg1 := 1, nArg2 := 2
//     DoFunc( nArg1, nArg2 )
//
//     FUNCTION DoParm( nParm1, nParm2, nParm3, nParm4 )
//     DEFAULT nParm1 TO 5, nParm2 TO 10, nParm3 TO 20, nParm4 TO 30	 
//
// Result:
//     nParm1 will equal 1, nParm2 will equal 2, nParm3 will equal 20,
//     and nParm4 will equal 30  
//
// WARNING: This directive must be typed EXACTLY as shown to work.
//


#command DEFAULT <var1> TO <value1> [,<varN> TO <valueN>] =>;
         <var1> := IF(<var1> == NIL,<value1>,<var1>);
         [; <varN> := IF(<varN> == NIL,<valueN>,<varN>)]

