// TBMEMO - TBrowse of a memo field
// 
// Copyright (c) 1990 Nantucket Corp.  All rights reserved.
//
// compile with /n/w/a
//

#include "Inkey.ch"
#include "SetCurs.ch"

#define MY_HSEP  ""
#define MY_CSEP  "  "

PROCEDURE TbMemo( )

  USE c:\Test ALIAS MemoFile

  SETCOLOR("N/BG")
  CLEAR SCREEN
  
  SETCOLOR("W+/N")
  @ 0, 0 SAY REPLICATE(CHR(178),80)
  SETCOLOR("GR+/N")
  @ 0,34 SAY " THE Demo "

  SETCOLOR("gr+/gr")
  @ MAXROW(), 0 
  @ MAXROW(), 3 SAY 'Created on 6/10/90 by Craig Ogg and Savannah Brentnall, (c) Nantucket 1990'
  
  SETCOLOR("n/n")
  @ 3,12 CLEAR TO 21,72

  SET SCOREBOARD OFF

  SET CURSOR OFF
  BrowseMemo( "Text", StrTran( MemoFile->Text, chr(141) + chr(10), ' ' ), 2, 10, 20, 70 )
  SET CURSOR ON

  SET COLOR TO
  @ MAXROW(),0 CLEAR
  SETCURSOR( SC_NORMAL )

RETURN

//... TBrowseMemo( <cMemo>, <nTop>, <nLeft>, <nBott>, <nRight> ) 
//...
//... cMemo - Name of memo field to browse (fully qualified: alias->name)
//...
//... Returns: Browse object for memo field
//...
//... WARNING!!!!  This uses the cargo instance variable of the tbrowse, 
//...              so don't dare touch
//...
FUNCTION BrowseMemo( cTitle, cMemo, nTop, nLeft, nBott, nRight )
LOCAL oBrowse, oColumn, nLine := 1
LOCAL nWidth := ( (nRight - nLeft) -9)
LOCAL lCont  := .t.
LOCAL nKey   := 0

  //... Create new browse object
  oBrowse := TBrowseNew( nTop, nLeft, nBott, nRight )

  //... Add movement blocks

  oBrowse:goTopBlock    := {|| nLine := 1 }
  oBrowse:goBottomBlock := {|| nLine := MLCOUNT( cMemo, nWidth )}
  oBrowse:skipBlock     := {|nMove| SkipMemo( nMove, cMemo, @nLine, nWidth ) }

  //... Add color table
  oBrowse:colorSpec := "B/W, B/BG, N/W"

  //...Add row and column separators
  oBrowse:colSep  := MY_CSEP
  oBrowse:headSep := MY_HSEP

  //... Create line number column
  oColumn := TBColumnNew( "Line #", {|| STR(nLine, 6) } )
  oColumn:width := 6

  //... Create colour for line number
  oColumn:defColor := {3, 3}

  //... Add it to browse
  oBrowse:addColumn( oColumn )

  //... Create memo column
  oColumn := TBColumnNew( cTitle, {|| MEMOLINE( cMemo, nWidth, nLine )} )

  //... Add it to browse
  oBrowse:addColumn( oColumn )
  
  @ nTop, nLeft Clear to nBott, nRight

  oBrowse:colPos := 2
  DO WHILE (lCont)
    //... Stabilize browse (until done, or keystroke hit)
    DO WHILE (! oBrowse:stable) .AND. ((nKey := INKEY()) == 0)
      oBrowse:stabilize()
    ENDDO

    //... Everything stabilized
    IF oBrowse:stable
      IF (oBrowse:hitTop .OR. oBrowse:hitBottom)
        TONE(125,0)
      ENDIF

      IF nKey == 0
        nKey := INKEY(0)
      ENDIF
    ENDIF			 

    //... Handle keystrokes
    DO CASE
      CASE nKey == K_DOWN
        oBrowse:down()
      CASE nKey == K_UP
        oBrowse:up()
      CASE nKey == K_LEFT
        oBrowse:left()
      CASE nKey == K_RIGHT
        oBrowse:right()
      CASE nKey == K_PGDN
        oBrowse:pageDown()
      CASE nKey == K_PGUP
        oBrowse:pageUp()
      CASE nKey == K_CTRL_PGUP
        oBrowse:goTop()
      CASE nKey == K_CTRL_PGDN
        oBrowse:goBottom()
      CASE nKey == K_ESC
        lCont := .F.
    ENDCASE
  ENDDO
  
RETURN NIL

STATIC FUNCTION SkipMemo( nMove, cMemo, pnLine, nWidth )
LOCAL nMoved    := 0
LOCAL nLastLine := MLCOUNT( cMemo, nWidth )

  IF nMove > 0
    IF pnLine + nMove > nLastLine
      nMoved := nLastLine - pnLine
      pnLine := nLastLine
    ELSE
      nMoved := nMove
      pnLine += nMove
    ENDIF
  ELSE
    IF pnLine + nMove < 1
      nMoved := 1 - pnLine
      pnLine := 1
    ELSE
      nMoved := nMove
      pnLine += nMove
    ENDIF
  ENDIF

RETURN (nMoved)


